// đọc  góc Y từ mpu6050 sử dụng bộ lọc bù
#include <Wire.h>
#define   RAD2DEG   57.295779    
#define   OFFSET    0

long preTime=0;
float xAngle,yAngle;

void setup() 
{
  MPUConfig();
  Serial.begin(115200);
}
void loop() 
{
  float angle = getYAngle();
  Serial.println(angle);
}
float getYAngle()
{
  int accRawX, accRawY, accRawZ, gyroRawX, gyroRawY;
  float accelerationXAngle,accelerationYAngle;
  float gyroXAngle,gyroYAngle;
  
  Wire.beginTransmission(0x68);
  Wire.write(0x3B); 
  Wire.endTransmission(false);
  Wire.requestFrom(0x68, 12, true);
  
  accRawX = Wire.read() << 8 | Wire.read(); 
  accRawY = Wire.read() << 8 | Wire.read();
  accRawZ = Wire.read() << 8 | Wire.read();
  Wire.read();
  Wire.read();
  gyroRawX = Wire.read() << 8 | Wire.read(); 
  gyroRawY = Wire.read() << 8 | Wire.read();
  
  accelerationXAngle = atan((accRawY / 16384.0) / sqrt(pow((accRawX / 16384.0), 2) + pow((accRawZ / 16384.0), 2))) * RAD2DEG;
  accelerationYAngle = atan(-1 * (accRawX / 16384.0) / sqrt(pow((accRawY / 16384.0), 2) + pow((accRawZ / 16384.0), 2))) * RAD2DEG;
  gyroXAngle = gyroRawX / 131.0;
  gyroYAngle = gyroRawY / 131.0;
  long timeNow = millis();
  xAngle = 0.98 * (xAngle + gyroXAngle * (timeNow - preTime) / 1000) + 0.02 * accelerationXAngle;
  yAngle = 0.98 * (yAngle + gyroYAngle * (timeNow - preTime) / 1000) + 0.02 * accelerationYAngle;
  preTime = millis();
  return yAngle + OFFSET;
}
void MPUConfig()
{
  Wire.begin(); 
  Wire.beginTransmission(0x68);
  Wire.write(0x6B);
  Wire.write(0);
  Wire.endTransmission(true);

  Wire.beginTransmission(0x68);
  Wire.write(0x19);
  Wire.write(0);
  Wire.endTransmission(true);

  Wire.beginTransmission(0x68);
  Wire.write(0x1B);
  Wire.write(0);
  Wire.endTransmission(true);

  Wire.beginTransmission(0x68);
  Wire.write(0x1C);
  Wire.write(0);
  Wire.endTransmission(true);
}
