/*
************************************************************
*                   DO VAN TOC DONG CO TRAI                *   
************************************************************
*/
#define         LEFTMOTORINB            12
#define         LEFTMOTORINA            11
#define         LEFTMOTOREN             13
#define         LEFTENCODERCHANNELB     7  
#define         LEFTENCODERCHANNELA     2

volatile long leftEncoderCounter = 0;
void leftEncoderIntFunc()      
{   
  if(digitalRead(LEFTENCODERCHANNELB)==HIGH)   {       leftEncoderCounter = leftEncoderCounter - 1;  }
  else                                 {       leftEncoderCounter = leftEncoderCounter + 1;  }  
}
void setup() 
{ 
  leftMotorConfig();
  Serial.begin(115200);
}
void loop() 
{
  analogWrite(LEFTMOTOREN, 255);    // động cơ trái quay 100%
  digitalWrite(LEFTMOTORINA,LOW);
  digitalWrite(LEFTMOTORINB,HIGH);
  Serial.println(getSpeed());
}
float getSpeed()
{
  /*
    Encoder 13 xung, động cơ 1 : 34
    1 Vong        <-->    442 xung
    0.08 s        -->   X / 442              Vòng
    60 s          -->   60 * (X / 442) / 0.08 = X * 1.6968 Vong / phut
  */
  
  static unsigned long mSecond = millis();
  static float leftMotorSpeed = 0;
  static long counter , lastEncoderCounter = 0 ;
  if (millis() - mSecond >= 80) // mỗi 80ms thì mới đọc một lần
  {
    mSecond = millis();
    counter = leftEncoderCounter - lastEncoderCounter;
    lastEncoderCounter = leftEncoderCounter;
    leftMotorSpeed = counter * 1.6968;
  }
  return leftMotorSpeed;
}
void leftMotorConfig()          
{  
  /* cấu hình chân điều khiển */
  pinMode(LEFTMOTORINB, OUTPUT);
  pinMode(LEFTMOTORINA, OUTPUT);
  pinMode(LEFTMOTOREN, OUTPUT);

  /* cấu hình chân đọc encoder và khai báo hàm ngắt encoder */    
  pinMode(LEFTENCODERCHANNELA,INPUT);
  pinMode(LEFTENCODERCHANNELB,INPUT);
  attachInterrupt(digitalPinToInterrupt(LEFTENCODERCHANNELA), leftEncoderIntFunc, RISING);      // RISING: ngắt xung cạnh lên, leftEncoderIntFunc: tên hàm ngắt
}

//-----------------------------------------------------------
/*
************************************************************
*                   DO VAN TOC CA 2 DONG CO                *   
************************************************************
*/
//#define         LEFTMOTORINB            12
//#define         LEFTMOTORINA            11
//#define         LEFTMOTOREN             13
//#define         LEFTENCODERCHANNELB     7 
//#define         LEFTENCODERCHANNELA     2
//#define         RIGHTMOTORINB           9
//#define         RIGHTMOTORINA           8
//#define         RIGHTMOTOREN            4
//#define         RIGHTENCODERCHANNELB    5  
//#define         RIGHTENCODERCHANNELA    3
//volatile long leftEncoderCounter = 0, EncoderP = 0;
//float VanToc=0;
//void leftEncoderIntFunc()      // hàm ngắt encoder của bánh trái 
//{   
//  if(digitalRead(LEFTENCODERCHANNELB)==HIGH)   {       leftEncoderCounter = leftEncoderCounter - 1;  }
//  else                                 {       leftEncoderCounter = leftEncoderCounter + 1;  }  
//}
//void rightEncoderIntFunc()      // hàm ngắt encoder của bánh phải 
//{   
//  if(digitalRead(RIGHTENCODERCHANNELB)==HIGH)    {       EncoderP = EncoderP - 1;  }
//  else                                 {       EncoderP = EncoderP + 1;  }  
//}
//void setup() 
//{ 
//  cauHinhMotor();
//  Serial.begin(115200);
//}
//void loop() 
//{
//  analogWrite(LEFTMOTOREN, 255);    // động cơ trái quay 100%
//  digitalWrite(LEFTMOTORINA,LOW);
//  digitalWrite(LEFTMOTORINB,HIGH);
//  
//  analogWrite(RIGHTMOTOREN, 255);    // động cơ phải quay 100%
//  digitalWrite(RIGHTMOTORINA,LOW);
//  digitalWrite(RIGHTMOTORINB,HIGH);
//  VanToc = getSpeed();
//  Serial.println(VanToc);
//}
//float getSpeed()
//{
//  /*
//    Encoder 13 xung, động cơ 1 : 34
//    1 Vong        <-->    442 xung
//    0.08 s        -->   X / 442              Vòng
//    60 s          -->   60 * (X / 442) / 0.08 = X * 1.6968 Vong / phut
//  */
//  
//  static unsigned long mSecond = millis();
//  static float VanToc = 0;
//  static long X, leftEncoderCounteruoc = 0;
//  if (millis() - mSecond >= 80) // mỗi 80ms thì mới đọc một lần
//  {
//    mSecond = millis();
//    X = (leftEncoderCounter + EncoderP)/2 - leftEncoderCounteruoc;
//    leftEncoderCounteruoc = (leftEncoderCounter + EncoderP)/2;
//    VanToc = X * 1.6968;
//  }
//  return VanToc;
//}
//void cauHinhMotor()
//{
//  /* cấu hình động cơ trái */
//  pinMode(LEFTMOTORINB, OUTPUT);
//  pinMode(LEFTMOTORINA, OUTPUT);
//  pinMode(LEFTMOTOREN, OUTPUT);
//
//  pinMode(LEFTENCODERCHANNELA,INPUT);
//  pinMode(LEFTENCODERCHANNELB,INPUT);
//  attachInterrupt(digitalPinToInterrupt(LEFTENCODERCHANNELA), leftEncoderIntFunc, RISING);      // RISING: ngắt xung cạnh lên, leftEncoderIntFunc: tên hàm ngắt
//
//   /* cấu hình động cơ phải */
//  pinMode(RIGHTMOTORINB, OUTPUT);
//  pinMode(RIGHTMOTORINA, OUTPUT);
//  pinMode(RIGHTMOTOREN, OUTPUT);
//  
//  pinMode(RIGHTENCODERCHANNELA,INPUT);
//  pinMode(RIGHTENCODERCHANNELB,INPUT);
//  attachInterrupt(digitalPinToInterrupt(RIGHTENCODERCHANNELA), rightEncoderIntFunc, RISING);      // RISING: ngắt xung cạnh lên, rightEncoderIntFunc: tên hàm ngắt
//}
