#define TRIGPIN  51     // chân TRIGPIN của HC-SR04
#define ECHOPIN  53     // chân ECHOPIN của HC-SR04

#define TIMEOUT   4000      // đơn vị (us)
void setup()
{
    Serial.begin(115200);     // giao tiếp Serial với baudrate 9600
    pinMode(TRIGPIN,OUTPUT);   // chân TRIGPIN sẽ phát tín hiệu
    pinMode(ECHOPIN,INPUT);    // chân ECHOPIN sẽ nhận tín hiệu
}
 
void loop()
{
  float distance = getDistance();
  /* In kết quả ra Serial Monitor */
  Serial.print(distance);
  Serial.println("cm");
  delay(200);
}
float getDistance()
{
  float duration;     // biến đo thời gian, don vi us
  float distance;     // biến lưu khoảng cách
  
  /* Phát xung từ chân TRIGPIN */
  digitalWrite(TRIGPIN,LOW);   // tắt chân TRIGPIN
  delayMicroseconds(2);
  digitalWrite(TRIGPIN,HIGH);   // phát xung từ chân TRIGPIN
  delayMicroseconds(10);     // xung có độ dài 10 microSeconds
  digitalWrite(TRIGPIN,LOW);    // tắt chân TRIGPIN
  
  /* Tính toán thời gian */
  // Đo độ rộng xung HIGH ở chân ECHOPIN. 
  duration = pulseIn(ECHOPIN,HIGH, TIMEOUT);  
  /* 
   TIMEOUT là thời gian tối đa để thoát khỏi hàm pulseIn.
   Nếu khoảng cách vật cản càng xa (trong tầm đo của cảm biến) thì hàm pulseIn càng tốn thời gian để thực hiện.
   Mặc định, nếu ta không truyền TIMEOUT thì thời gian tối đa để thoát khỏi hàm này là khoảng 200 (ms)
   Điều này không tốt cho xe cân bằng vì đòi hỏi phải cần tính toán nhanh,
   trong khi pulseIn sẽ làm trì hoãn thời gian tính toán để đo khoảng cách.
   Vì vậy ta phải thiết lập thời gian tối đa của hàm pulseIn để xe vừa có thể thực hiện 
   nhiệm vụ cân bằng và vừa tính được khoảng cách sao cho hợp lý. 
  */
  
  // Tính khoảng cách đến vật.
  distance = (duration/2/29.411);
  return distance;
}

